EDIT - task #8437

ITermTreeService provides a list method which supports filtering by TermTree.termType,
08/01/2019 12:26 PM - Andreas Kohlbecker

Status: Resolved Start date:

Priority: Priority14 Due date:

Assignee: Andreas Muller % Done: 80%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.9

Severity: normal

Description

e.g.:

public List<TermTree> list (TermType termType, Integer limit, Integer start, List<OrderHint>
orderHints, List<String> propertyPaths);

public Pager<TermTree> page (TermType termType, Integer pageSize, Integer pagelndex, List<OrderHint
> orderHints, List<String> propertyPaths);

Related issues:
Precedes EDIT - task #8436: featureTree/* services should filter the termTree... Closed

Associated revisions

Revision b820a890 - 08/01/2019 03:00 PM - Andreas Miiller

ref #8437 first implementation for listBy termType for TermTreeService, not yet tested

Revision 2ef4c225 - 08/02/2019 11:18 AM - Andreas Kohlbecker

ref #8437 using the listByRestriction method in favour of a new untested dao method & implementing page method in ITermTreeService

Revision 19b30c4f - 08/12/2019 12:05 PM - Andreas Kohlbecker

ref #8437 ITermTreeService termType Feature as filter includes also Character

Revision 1a5b2194 - 08/12/2019 04:18 PM - Andreas Kohlbecker
ref #8437 fixing LIE in DerivedUnitFacadeController

Revision acdfa184 - 08/23/2019 12:59 PM - Andreas Kohlbecker
ref #8437 using TermType.getGeneralizationOf() to expand the termType restriction

History

#1 - 08/01/2019 12:26 PM - Andreas Kohlbecker

- Precedes task #8436: featureTree/* services should filter the termTrees by the TermType Feature added

#2 - 08/01/2019 02:59 PM - Andreas Miiller

- Status changed from New to In Progress

- Priority changed from New to Priority14

- Target version changed from Unassigned CDM tickets to Release 5.9

- % Done changed from 0 to 40

implemented but no tests yet, but maybe you can integrate into controller already

#3 - 08/02/2019 11:19 AM - Andreas Kohlbecker
- Status changed from In Progress to Resolved

- % Done changed from 40 to 50
please can you review my changes?

#4 - 08/02/2019 05:27 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Andreas Kohlbecker

Have you tested with termType = Character which is a subtype for Feature. | don't think the "Restrictions" implementation will manage this correctly.

#5 - 08/02/2019 05:29 PM - Andreas Miiller

So we definetely should write tests before closing.

#6 - 08/05/2019 10:37 AM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Mtiller

Andreas Muller wrote:
Have you tested with termType = Character which is a subtype for Feature. | don't think the "Restrictions" implementation will manage this
correctly.

| did not understand this as requirement and | see two problems whith this:

1. From the TermTypes enum which is being used as filter it is not clear that using Feature will also include Character.
2. How would it be possible to get TermTrees for Feature without Character ?

Therefore | suggest to allow passing a Set of TermTypes as filter:
public List<TermTree> list (Set<TermType> termType, Integer limit, Integer start, List<OrderHint> orderHints,
List<String> propertyPaths);
public Pager<TermTree> page (Set<TermType> termType, Integer pageSize, Integer pageIndex, List<OrderHint>
orderHints, List<String> propertyPaths);
which is supported by the restrictions api out of the box.
#7 - 08/05/2019 10:55 AM - Andreas Miiller
- Assignee changed from Andreas Miller to Andreas Kohlbecker
Andreas Kohlbecker wrote:
Andreas Miiller wrote:
Have you tested with termType = Character which is a subtype for Feature. | don't think the "Restrictions" implementation will manage this
correctly.
| did not understand this as requirement and | see two problems whith this:

1. From the TermTypes enum which is being used as filter it is not clear that using Feature will also include Character.
2. How would it be possible to get TermTrees for Feature without Character ?

Therefore | suggest to allow passing a Set of TermTypes as filter:
public List<TermTree> list (Set<TermType> termType, Integer limit, Integer start, List<OrderHint>
orderHints, List<String> propertyPaths);
public Pager<TermTree> page (Set<TermType> termType, Integer pageSize, Integer pageIndex, List<OrderHint>
orderHints, List<String> propertyPaths);
which is supported by the restrictions api out of the box.
The javadoc says "Is subtype of {@link #Feature}" which to me is clear. Also the idea of the term types is to replace classes as classes are difficult to
handle sometimes. But the semantics should be the same. Therefore if using list(class, ....) you also do not expect that you need to pass all the

subclasses as a collection of classes. This is exactely the same behavior as for classes and it is by intention. Therefore | do not agree with the above
solution.
#8 - 08/12/2019 12:06 PM - Andreas Kohlbecker
- Status changed from Feedback to Resolved

- Assignee changed from Andreas Kohlbecker to Andreas Miiller
Agreed ... and implemented in the way you pointed out.

#9 - 08/23/2019 10:21 AM - Andreas Mdiller

To me it looks like commit 1a5b2194 is not related to this ticket. Can you please check?

#10 - 08/23/2019 10:28 AM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Andreas Kohlbecker
- % Done changed from 50 to 70
Andreas Kohlbecker wrote:
Agreed ... and implemented in the way you pointed out.
The current implementation is not generic as my first implementation was. It handles Characters as an explicit case. My first implementation did
handle ALL sub-types. Currently only this 1 subtype exists, but in future there might be more.
Also it might be nice to have a little test that it works. Have you tested in some environment?
#11 - 08/23/2019 01:06 PM - Andreas Kohlbecker
- Status changed from Feedback to Resolved
- Assignee changed from Andreas Kohlbecker to Andreas Mliller
- % Done changed from 70 to 80
my implementation now is generic.

Also it might be nice to have a little test that it works. Have you tested in some environment?

| positively tested manually with the cdm_additivity_ontology database. Unit-tests do not yet exist.
